--[[==========================================================
Duplicate Pattern Aliased

Author: Martin Dombrowa [md@strobotone.de]
Version: 1.0
==========================================================]]--

--menu entries / keybindings ---------------------------------

local menu_entry_ps =
{
  ["name"] = "Pattern Sequencer:Duplicate (Aliased)",
  ["invoke"] = function() 
      duplicateRangeAliased() 
    end
}
renoise.tool():add_menu_entry(menu_entry_ps)

local menu_entry_pm =
{
  ["name"] = "Pattern Matrix:Pattern:Duplicate (Aliased)",
  ["invoke"] = function() 
      duplicateRangeAliased() 
    end
}
renoise.tool():add_menu_entry(menu_entry_pm)

local keybinding =
{
  ["name"] = "Pattern Sequencer:Edit:Duplicate (Aliased)",
  ["invoke"] = function() 
      duplicateRangeAliased() 
    end
}
renoise.tool():add_keybinding(keybinding)

--functions --------------------------------------------------

function duplicatePatternAliased(srcPtnIdx, dstPtn)
  for i = 1, #dstPtn.tracks
    do
      local trk = dstPtn.tracks[i]
  
      if trk.alias_pattern_index == 0 and not trk.is_empty 
      then
        trk.alias_pattern_index = srcPtnIdx
      end
    end
end

function duplicateRangeAliased()
  local sng = renoise.song()
  local seq = sng.sequencer
  
  local selRange = seq.selection_range
  
  local startIdx = selRange[1]
  local endIdx = selRange[2]
   --return if selection is empty
  if startIdx == 0 and endIdx == 0
  then end
  
  seq:clone_range(startIdx, endIdx)
  local rangeSize = (endIdx - startIdx) + 1
  --print("rangeSize :"..rangeSize)

  for srcSeqIdx = startIdx, endIdx
    do    
      local srcPtnIdx = seq:pattern(srcSeqIdx)
      --print("srcPtnIdx :"..srcPtnIdx)
    
      local dstPtnIdx = seq:pattern(srcSeqIdx + rangeSize)
      --print("dstPtnIdx :"..dstPtnIdx)
      
      local dstPtn = sng.patterns[dstPtnIdx]
      
      duplicatePatternAliased(srcPtnIdx, dstPtn)
       
    end
    
end

